/* This function handles the input of a password. */
 
#include <Xm/Xm.h>
 
extern char *passwd;

 
/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */ 
void
CheckPasswd(Widget text_w, XtPointer client_data, XtPointer call_data)
{
    char *new;
    int len;
    XmTextVerifyCallbackStruct *cbs = 
        (XmTextVerifyCallbackStruct *) call_data;

    if (cbs->reason == XmCR_ACTIVATE) {
/*
        printf ("Password: %s\n", passwd);
*/
        return;
    }

    if (cbs->startPos < cbs->currInsert) {   /* Backspace */
        cbs->endPos = strlen (passwd);       /* Delete from here to end */
        passwd[cbs->startPos] = 0;           /* Backspace--terminate */
        return;
    }

    if (cbs->text->length > 1) {
        cbs->doit = False;  /* Don't allow "paste" operations */
        return;             /* Make the user *type* the password! */
    }

    new = XtMalloc (cbs->endPos + 2); /* new char + NULL terminator */
    if (passwd) {
        strcpy (new, passwd);
        XtFree (passwd);
    } else
        (int) new[0] = NULL;
    passwd = new;
    strncat (passwd, cbs->text->ptr, cbs->text->length);
    passwd[cbs->endPos + cbs->text->length] = 0;

    for (len = 0; len < cbs->text->length; len++)
        cbs->text->ptr[len] = '*';
}
