/* DirSelectCB() 
**  Handles input of the user data directory 
**/

 
/* All header files listed in cdmaker.h */
#include "cdmaker.h"
/* All global variables defined in cdmaker-global.h */
#include "cdmaker-global.h"



/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
void
DirSelectCB(Widget widget, XtPointer client_data, XtPointer call_data)
{
    Widget dialog;
    XmString t = XmStringCreateLocalized ("Enter Data Directory:");
    extern void read_dir();
    Arg args[5];
    int n = 0;

    /* Create the dialog -- the PushButton acts as the DialogShell's
    ** parent (not the parent of the PromptDialog).
    */
    XtSetArg (args[n], XmNselectionLabelString, t); n++;
    XtSetArg (args[n], XmNautoUnmanage, False); n++;
    dialog = (XtPointer) XmCreatePromptDialog (widget, "prompt", args, n);
    XmStringFree (t); /* always destroy compound strings when done */

    /* When the user types the name, call read_dir() */
    XtAddCallback (dialog, XmNokCallback, read_dir, widget);

    /* If the user selects cancel, just destroy the dialog */
    XtAddCallback(dialog, XmNcancelCallback, (XtPointer) XtDestroyWidget, NULL);

    /* No help is available */
    XtSetSensitive ( 
        (XtPointer) XmSelectionBoxGetChild (dialog, XmDIALOG_HELP_BUTTON), 
        False);
    XtManageChild (dialog);

    XtPopup (XtParent (dialog), XtGrabNone);
}


/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
/* read_dir() --the text field has been filled in. */
void
read_dir(Widget widget, XtPointer client_data, XtPointer call_data)
{
    Widget push_button = (Widget) client_data;  
    XmSelectionBoxCallbackStruct *cbs = 
        (XmSelectionBoxCallbackStruct *) call_data;

    /* Convert the compound string to a regular C string */
    XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &data_dir_selection);
    
    wprint ("\n\nCurrent data directory: %s\n", data_dir_selection);
 
    XtDestroyWidget(widget);
    

}

 
