/* Callback routine for help button. */
 
#include <Xm/Xm.h>
 
extern Widget toplevel;
 
 
/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */

/* The Help message */
#define MSG0 \
"xppp:  Initiate or terminate a PPP link.\n\n\n\
Put your phone list in the file PPP_DATA_DIR/PHONE_FILE.\n\n\
Ping Host will send a single packet to the hosts\n\
defined in PPP_DATA_DIR/HOST_FILE.\n
Click the right mouse button when on the\n\
Ping Host button to see your list of hosts,\n\
else the first host in the list is used."

/* The About message */
#define MSG1 \
"xppp\n\
Robert S. Mallozzi\n\
mallozzir@cspar.uah.edu"

void
HelpCB(Widget widget, XtPointer client_data, XtPointer call_data)
{ 
    static Widget dialog;
    XmString popup_title;
    int item_no = (int) client_data;
     
    /* Help */
    if (item_no == 0) {

       Arg args[5];
       int n = 0;
       XmString msg = XmStringCreateLtoR (MSG0, XmFONTLIST_DEFAULT_TAG);
       XtSetArg (args[n], XmNmessageString, msg); n++;
       dialog = (XtPointer) XmCreateInformationDialog (toplevel, "help", 
           args, n); 

       /* Set the dialog title */
       popup_title = XmStringCreateLocalized ("Help");
       XtVaSetValues (dialog,
           XmNdialogTitle, popup_title, 
           NULL);
       XmStringFree (popup_title);
        
       /* Get rid of the HELP button */
       XtUnmanageChild ((XtPointer) XmMessageBoxGetChild (dialog, 
           XmDIALOG_HELP_BUTTON));
       /* Get rid of the CANCEL button */
       XtUnmanageChild ((XtPointer) XmMessageBoxGetChild (dialog, 
           XmDIALOG_CANCEL_BUTTON));
    }

    /* About */
    if (item_no == 1) {

       Arg args[5];
       int n = 0;
       XmString msg = XmStringCreateLtoR (MSG1, XmFONTLIST_DEFAULT_TAG);
       XtSetArg (args[n], XmNmessageString, msg); n++;
       dialog = (XtPointer) XmCreateInformationDialog (toplevel, 
           "about", args, n); 

       /* Set the dialog title */
       popup_title = XmStringCreateLocalized ("About");
       XtVaSetValues (dialog,
           XmNdialogTitle, popup_title, 
           NULL);
       XmStringFree (popup_title);
        
       /* Get rid of the HELP button */
       XtUnmanageChild ((XtPointer) XmMessageBoxGetChild (dialog, 
           XmDIALOG_HELP_BUTTON));
       /* Get rid of the CANCEL button */
       XtUnmanageChild ((XtPointer) XmMessageBoxGetChild (dialog, 
           XmDIALOG_CANCEL_BUTTON));
    }    

    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone); 
}
