/* This function establishes a one-way pipe between 
**  subprocess -> parent and starts the child process "command".
*/ 

#include <stdio.h>
#include <Xm/Xm.h>

extern XtAppContext app;
extern Widget text_output;
extern int pipefd[2], pid;
extern char *pass_command_1, *pass_command_2; 
extern void GetFromChild();
    
/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
void
OpenPipe (char *command)
{
    /* pipe: child -> parent */
    pipe (pipefd);                  

    /* Create a child process */
    pid = fork();
    
    if (pid == 0) {
       /* In child process */
       
       /* Redirect stdin */
       close (pipefd[0]);             
       close (1);
       dup (pipefd[1]);    
         
       /* Execute the new command, then teminate the child process */
       if (execlp (command, "OpenPipe", 
          pass_command_1, pass_command_2, NULL) == -1) {
        
          printf ("Error executing command\n %s\n", command);
          perror ("OpenPipe");
          /* sigchld catcher handles the error */
          _exit (255);
       }
     }
     else if (pid > 0) {
       /* In parent process */
              
       close (pipefd[1]);
       XtAppAddInput (app, pipefd[0], (XtPointer) XtInputReadMask,
           GetFromChild, text_output);

    }
    else {
       fprintf (stderr, "Unable to fork process %s\n", command);
       exit (1);
    }
}
