/* PhoneSelectionDialogCB() 
**  The OK button was selected or the user 
**  input a name by himself.  Determine whether the result is
**  a valid name by looking at the "reason" field.
**/

#include <Xm/Xm.h> 

extern char *pass_command_1;
extern Widget password_dialog; 
extern void CheckPasswd();
extern void DestroyPasswd();


/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
void
PhoneSelectionDialogCB(Widget widget, XtPointer client_data, XtPointer call_data)
{
    char msg[256], *prompt, *value;
    int dialog_type;
    XmSelectionBoxCallbackStruct *cbs = 
        (XmSelectionBoxCallbackStruct *) call_data;
    Widget text_w; 
    static Position x, y;
    const char delimiter[] = " ";
    XmString t = XmStringCreateLocalized ("Enter Password:");
    Arg args[5];
    int n = 0;
    
      
    switch (cbs->reason) {
        case XmCR_OK:
            XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);

            /* Strip off the name associated with the phone number 
            **  by separating the string based on delimiter.  The phone
            **  number is the second token.
            */
            pass_command_1 = strtok( value, delimiter);
            pass_command_1 = strtok( NULL, delimiter);
/*
            prompt = "Selection: ";
            dialog_type = XmDIALOG_MESSAGE;
*/
            break;
        case XmCR_NO_MATCH:
            prompt = "Not a valid selection: ";
            dialog_type = XmDIALOG_ERROR;

            XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);
            sprintf (msg, "%s%s", prompt, value);
            XtFree (value);
            (void) PostDialog (XtParent (XtParent (widget)), dialog_type, msg);
            XtPopdown (XtParent (widget));
            XtDestroyWidget (widget); 
            return;
            break;
        default:
            prompt = "Unknown selection: ";
            dialog_type = XmDIALOG_ERROR;

            XmStringGetLtoR (cbs->value, XmFONTLIST_DEFAULT_TAG, &value);
            sprintf (msg, "%s%s", prompt, value);
            XtFree (value);
            (void) PostDialog (XtParent (XtParent (widget)), dialog_type, msg);
            return;
            break; 
    }

    /* Popup a dialog to get the user password.
    **  The password is stored in pass_command_2, and is passed
    **  to PPP_DIR/ppp-start.
    */
    XtSetArg (args[n], XmNselectionLabelString, t); n++;
    XtSetArg (args[n], XmNautoUnmanage, False); n++;
    password_dialog = (XtPointer) XmCreatePromptDialog (widget, "prompt", 
        args, n);
    XmStringFree (t); /* Always destroy compound strings when done */

    /* Get the text widget ID */
    text_w = (XtPointer)XmSelectionBoxGetChild (password_dialog, XmDIALOG_TEXT);    

    XtAddCallback(text_w, XmNmodifyVerifyCallback, CheckPasswd, NULL);
    XtAddCallback(password_dialog, XmNokCallback, DestroyPasswd, NULL);
/*
    XtAddCallback(text_w, XmNactivateCallback, DestroyPasswd, NULL);
*/
    /* If the user selects cancel, just destroy the dialog */
    XtAddCallback(password_dialog, XmNcancelCallback, 
        (XtPointer) XtDestroyWidget, NULL);

    /* No help is available */
    XtSetSensitive ( (XtPointer) XmSelectionBoxGetChild (password_dialog, 
        XmDIALOG_HELP_BUTTON), False);
    XtManageChild (password_dialog);

    XtPopup (XtParent (password_dialog), XtGrabNone);


}


 
