/* PostDialog() -- A generalized routine that allows the programmer
**  to specify a dialog type (message, information, error, help,
**  etc..), and the message to show.
**/
 
#include <Xm/Xm.h>
 

 
/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
Widget
PostDialog(Widget parent, int dialog_type, char *msg)
{
    Widget dialog;
    XmString text;

    dialog = (XtPointer) XmCreateMessageDialog (parent, "dialog", NULL, 0);
    text = XmStringCreateLocalized (msg);
    XtVaSetValues (dialog,
        XmNdialogType,    dialog_type,
        XmNmessageString, text,
        NULL);
    XmStringFree (text);

    XtUnmanageChild ((XtPointer)
        XmMessageBoxGetChild (dialog, XmDIALOG_CANCEL_BUTTON));
    XtSetSensitive ((XtPointer)
        XmMessageBoxGetChild (dialog, XmDIALOG_HELP_BUTTON), False);

    XtAddCallback (dialog, XmNokCallback, (XtPointer) XtDestroyWidget, NULL);

    XtManageChild (dialog);
    return dialog;
}
