/* Callback for the "Initiate PPP Link" button. 
**  Popup a selection box that allows the user to select the 
**  number to dial, read from the file PPP_DATA_DIR/PHONE_FILE.
**  Callback for the OK button  popups a DialogShell to get the user password.
**  The actual command to initiate the link occurs in the callback
**  for the password dialog (DestroyPasswd()).
*/ 

#include "xppp.h" 
#include <stdio.h>
#include <Xm/Xm.h>
 
extern void PhoneSelectionDialogCB();
 

/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
void
Start_ppp(Widget widget, XtPointer client_data, XtPointer call_data)
{
    Widget dialog;
    XmString popup_title, t;
    XmString *str;
    int i;

    /* Popup a selection list widget for choosing the number to dial.
    **  The data is read from PPP_DATA_DIR/PHONE_FILE.
    **  The number is stored in pass_command_1 for now, and is passed
    **  to PPP_DIR/ppp-start after the user password is obtained.
    */

    /* Read the data */
    FILE *phone_file;
    char file_name[MAX_STRING] = PPP_DATA_DIR;
    char temp_file_name[MAX_STRING] = PHONE_FILE;
        
    char name[MAX_STRING], number[MAX_STRING], newline;
    char *names[MAX_PHONE];
    char *numbers[MAX_PHONE];

    typedef struct {
        char *label;
        char **name_list;
        char **number_list;
        int num_in_list;
    } ListItem;
    
    ListItem phone_items = { "Phone List", names, numbers, XtNumber (names) };

    strcat (file_name, "/");
    strcat (file_name, temp_file_name);

    phone_file = fopen (file_name, "r");
    if (phone_file == NULL) {
       perror ("start-ppp");      
       exit (1);
    }    

    i = 0;
    str  = (XmString *) XtMalloc (MAX_PHONE * sizeof (XmString));
    while (fscanf (phone_file, "%s%s%c", name, number, &newline) != EOF) {
 
          phone_items.name_list[i] = name;          
          phone_items.number_list[i] = number;

          /* Concatenate name+number for display in the selection widget */
          strcat (phone_items.name_list[i], "   ");
          strcat (phone_items.name_list[i], phone_items.number_list[i]);

          str[i] = XmStringCreateLocalized (phone_items.name_list[i]);          

          i++;
    }
    phone_items.num_in_list = i;   
    fclose (phone_file);
     
    /* Set the dialog title */
    popup_title = XmStringCreateLocalized ("Selection");

    t = XmStringCreateLocalized (phone_items.label);
    (Widget) dialog = XmCreateSelectionDialog (widget, "selection", NULL, 0);
    XtVaSetValues (dialog,
        XmNdialogTitle,     popup_title,
        XmNlistLabelString, t,
        XmNlistItems,       str,
        XmNlistItemCount,   phone_items.num_in_list,
        XmNmustMatch,       True,
        NULL);

    /* APPLY and HELP not available */
    XtSetSensitive (
        (XtPointer) XmSelectionBoxGetChild (dialog, XmDIALOG_APPLY_BUTTON), 
        False);
    XtSetSensitive (
        (XtPointer) XmSelectionBoxGetChild (dialog, XmDIALOG_HELP_BUTTON), 
        False);

    XtAddCallback (dialog, XmNokCallback, 
        PhoneSelectionDialogCB, NULL);
    XtAddCallback (dialog, XmNnoMatchCallback, 
        PhoneSelectionDialogCB, NULL);

    XmStringFree (popup_title);
    XmStringFree (t);
    while (--i >= 0)
        XmStringFree (str[i]); /* Free elements of array */
    XtFree ((XtPointer) str);  /* Free array pointer */

    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone);
}
