/* Callback for the "Terminate PPP Link" button   
**  Popup a WarningDialog displaying
**  the text passed as the client data parameter.
*/ 

#include <Xm/Xm.h>

extern void TerminateOk(); 
     
/*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   */
void
Stop_ppp(Widget button, XtPointer client_data, XtPointer call_data)
{
    Widget dialog;
    XmString xm_string, popup_title;
    Arg args[5];
    int n = 0;
    char *text = (char *) client_data;

    /* Set the label for the dialog */
    xm_string = XmStringCreateLocalized (text);
    XtSetArg (args[n], XmNmessageString, xm_string); n++;

    /* Create the WarningDialog as child of button */
    dialog = (XtPointer) XmCreateWarningDialog (button, "warning", args, n);

    /* Set the dialog title */
    popup_title = XmStringCreateLocalized ("Notice");
    XtVaSetValues (dialog,
        XmNdialogTitle, popup_title, 
        NULL);
       
    /* No longer need the compound strings, free them */
    XmStringFree (xm_string);
    XmStringFree (popup_title);

    /* Get rid of the HELP button */
    XtUnmanageChild ((XtPointer) XmMessageBoxGetChild (dialog, 
        XmDIALOG_HELP_BUTTON));
    
    /* Add the callback routine */
    XtAddCallback (dialog, XmNokCallback, TerminateOk, NULL);

    /* Manage the dialog, and realize */
    XtManageChild (dialog);
    XtPopup (XtParent (dialog), XtGrabNone);
}
 
