/* xppp.h
**
** mallozzir@cspar.uah.edu, 1996 Oct
*/


/* Type of protocol.  This parameter is used only to label the 
**  widget buttons.
*/
#define PROTOCOL "PPP"

/* The maximum string size for file names, etc */
#define MAX_STRING 80

/* Directories containing the shell scripts and data files that handle the 
** connection.  Length limited to MAX_STRING characters
**
** PPP_DIR:  Contains three shell scripts:
**    1.  ppp-start: dials modem and logs in user
**    2.  ppp-stop:  hangs up the modem
**    3.  ppp-ping:  pings a host with a single packet
**
** PPP_DATA_DIR:  Contains two files:
**    1.  ppp-ping-list: list of host names and IP addresses for ping menu
**    2.  ppp-phone-list: list of names and phone numbers for dial selection
*/
/*
#define PPP_DIR      "/usr/sbin"
#define PPP_DATA_DIR "/usr/sbin"
*/
#define PPP_DIR      "/home/mallors/xppp/scripts"
#define PPP_DATA_DIR "/home/mallors/xppp/scripts"

/* Filenames only; PPP_DATA_DIR is prepended automatically */
#define HOST_FILE    "ppp-ping-list"
#define PHONE_FILE   "ppp-phone-list"

/* The maximum number of phone numbers that can be stored 
** in PPP_DATA_DIR/ppp-phone-list 
*/
#define MAX_PHONE 10

/* The maximum number of hosts that can be stored 
** in PPP_DATA_DIR/ppp-ping-list 
*/
#define MAX_HOSTS 10

/* The file that is periodically checked to see if the link is up 
**  The program attempts to open the file for reading.  If the file 
**  exists, then the link is up, else the link is down
*/
#define LINK_FILE  "/var/run/ppp0.pid"

/* Directory for the pixmaps xppp_red.xpm, xppp_green.xpm */
#define PIXMAP_DIR "/home/mallors/xppp"

/* And the pixmaps... */
#define PIXMAP_GO "xppp_green.xpm"
#define PIXMAP_STOP "xppp_red.xpm"


/* End xppp.h */
